/******************************************************************************
 *
 * bung 14  Martin Hess, MC2, 28.9.2001
 *
 ******************************************************************************
 */

#include "CB_TSU2.h" 
#include "ioh83067.h"

#define Schalter (*(volatile unsigned char*)(0x400030))

void init(void); // Initialisiert Programm
void start_timer(void); // Started Timer
void Disp_Time(unsigned char sec, unsigned char min, unsigned char hour, unsigned char where); // Zeigt Zeit an
void Time1(void); 

int main (void)
{ 
unsigned char sec;
unsigned char min;
unsigned char hour;
unsigned char sec2;
unsigned char min2;
unsigned char hour2;
unsigned int time;  
unsigned int time2;  
char dummy[21];

init(); 
start_timer(); 
time = 0;        
time2 = 0;
sec = 0;
min = 0;
hour = 0;         
sec2 = 0;
min2 = 0;
hour2 = 0;         
do  
	{
	if ((FRT_TISRA & 0x01) == 1)
	 {          
	 FRT_TISRA = 0x88; // clears captured flag
	 time++;       
	 //CBTSU_DispInt(2,time);
	 if (time == 100) {
	 	sec++;
	 	time = 0;	 	
	 	if (sec == 60) {
	 		min++;
	 		sec = 0;
	 		}; // of sec
	 	if (min == 60) {
	 		hour++;
	 		min = 0;
	 		}; // of min
	 	if (hour == 24) hour = 0;
	 	Disp_Time(sec,min,hour,2);
		}; // of time
	 // individual startable clock
	 if ((Schalter & 0x01) != 0){
	 	time2++;
	 	if (time2 == 100) {
	 	sec2++;
	 	time2 = 0;	 	
	 	if (sec2 == 60) {
	 		min2++;
	 		sec2 = 0;
	 		}; // of sec
	 	if (min2 == 60) {
	 		hour2++;
	 		min2 = 0;
	 		}; // of min
	 	if (hour2 == 24) hour = 0;
	 	Disp_Time(sec2,min2,hour2,3);
	 	}; // of if time == 100
	 	}; // of individual clock
	 }; // of if FRT_TISRA  
	} // of do
while(1);
} // of main  

void init(void)
{
LCD_IWrite(0x01); //lscht LCD  
CBTSU_DispString(1,"Uebung 14 Timer");
} // of init 
                   
void start_timer(void)
{
FRT_TIOR0 = 0x8a; // GRB=Outp_compare; GRA=Outp_compare, 1
FRT_TCR0 = 0xa3; // Timer in f/8 mode; TCNT is cleared by GRA

FRT_GRA1L = 0x4f;
FRT_GRA1H = 0x5b; // GRA = 23375
 
FRT_TSTR = 0x01; //startet counter 0
} // of start_timer                   

void Disp_Time(unsigned char sec, unsigned char min, unsigned char hour, unsigned char where)
{ 
LCD_XY(2,where);
LCD_Char((hour/10)+'0');
LCD_Char((hour%10)+'0');  
LCD_Char(0x2e); // '.'
LCD_Char((min/10)+'0');
LCD_Char((min%10)+'0');
LCD_Char(0x2e); // '.'
LCD_Char((sec/10)+'0');
LCD_Char((sec%10)+'0');
} // of Disp_Time